# ============================================
#  Synthesis script - Leonardo Spectrum
# ============================================
#  Example 1 / HERON-IO2V
# ============================================

puts ""
puts " Synthesis script for HERON-IO2V2 Example 1"
puts ""

# Global timing constraints (100 MHz)
set input2register 10.0
set register2output 10.0
set register2register 10.0

#Technology settings and then load library
set part 2V1000fg456
set process 4
set wire_table xcv2-1000-4_wc
load_library xcv2

#Read in the design
read { ../../Common/HE_RWCLK.vhd
       ../../Common/HE_WR_6F.vhd
       ../../Common/V2_RD_6F.vhd
       ../../Common/HE_USER.vhd
       ../../Common/HE_SCLK.vhd
       ../../Common/HE_ADC.vhd
       ../../Common/HE_DAC.vhd
       ../Src/HSB1.vhd
       ../Src/USER_AP1.vhd
       ../../Common/TOP.vhd }

#Optimize the design and apply timing
optimize -target xcv2 -chip -area -effort quick -hierarchy auto 
optimize_timing

#Write out the edf netlist for PnR
auto_write Ex1_top.edf
