
/*
 * Initial main.c file generated by Glade. Edit as required.
 * Glade will not overwrite this file.
 */

#ifdef HAVE_CONFIG_H
#  include <config.h>
#endif

#include <gnome.h>

#include "interface.h"
#include "support.h"

int main_loop    = 1;
int data_free    = 1;		// When we're still busy displaying keep this to 0
int data_display = 0;		// Will be set to 1 when there's data to display

extern int  stopthread;
extern int  savethefile;
extern char savefilename[256]; 
extern int  openthefile;
extern char openfilename[256]; 

struct Params
{
	void *buf1;
	void *buf2;
	int   bufsize1;
	int   bufsize2;
};

extern struct Params params;

void DrawWindow(int *buf1, int bufsize1, int *buf2, int bufsize2);

void SaveUserFile(struct Params *p)
{
   if (savethefile)
   {
      FILE *f;
      f = fopen(savefilename, "w");
      if (f)
      {
         int i;
         for (i=0;i<p->bufsize1;i++) fprintf(f, "%d\n", ((short*)p->buf1)[i]);
         for (i=0;i<p->bufsize2;i++) fprintf(f, "%d\n", ((short*)p->buf2)[i]);
         fclose(f);
      }
      savethefile = 0;
   }		         
}

void OpenUserFile(void)
{
   if (openthefile)
   {
      FILE *f;
      f = fopen(openfilename, "r");
      if (f)
      {
         int          n=0, more=1;
         static short data[4096];

         while (more)
         {
            fscanf(f, "%d\n", &data[n++]);
            if (ferror(f)) more=0;
            if (feof  (f)) more=0;
            if (n > 4095 ) more=0;
         }
         params.buf1     =  data;
         params.buf2     = &data[n/2];
         params.bufsize1 =  n/2;
         params.bufsize2 =  n/2;
         DrawWindow(params.buf1, params.bufsize1, params.buf2, params.bufsize2);
         fclose(f);
      }
      openthefile = 0;
   }		         
}

int
main (int argc, char *argv[])
{
  GtkWidget *window1;
  int        loop  = 1;

#ifdef ENABLE_NLS
  bindtextdomain (GETTEXT_PACKAGE, PACKAGE_LOCALE_DIR);
  bind_textdomain_codeset (GETTEXT_PACKAGE, "UTF-8");
  textdomain (GETTEXT_PACKAGE);
#endif

  /* init threads */
  g_thread_init(NULL);
  gdk_threads_init();

  gnome_program_init (PACKAGE, VERSION, LIBGNOMEUI_MODULE,
                      argc, argv,
                      GNOME_PARAM_APP_DATADIR, PACKAGE_DATA_DIR,
                      NULL);

  /*
   * The following code was added by Glade to create one of each component
   * (except popup menus), just so that you see something after building
   * the project. Delete any components that you don't want shown initially.
   */
  window1 = create_window1 ();
  gtk_widget_show (window1);

  DrawWindow((int *)params.buf1, params.bufsize1, (int *)params.buf2, params.bufsize2);

  //gtk_main ();
  while (main_loop)
  {
     while (gtk_events_pending())
     {
        main_loop = gtk_main_iteration();
     }

     if (data_display)
     {
         DrawWindow(params.buf1, params.bufsize1, params.buf2, params.bufsize2);
         while (gtk_events_pending())
         {
            main_loop = gtk_main_iteration();
         }
         if (savethefile) SaveUserFile(&params);
         HeDelay(10);
         data_free    = 1;
         data_display = 0;
     }
     else
     if (stopthread)
     {
         if (savethefile) SaveUserFile(&params);
	 if (openthefile) OpenUserFile();
     }
  }
  return 0;
}

