// heronio2.cpp : Defines the entry point for the application.
//

#include "stdafx.h"
#include "resource.h"
#include "commdlg.h"
#include "stdio.h"
#include "math.h"
#include "process.h"
#include "errno.h"

#define MAX_LOADSTRING 100

// Global Variables:
HINSTANCE hInst;								// current instance
TCHAR szTitle[MAX_LOADSTRING];								// The title bar text
TCHAR szWindowClass[MAX_LOADSTRING];								// The title bar text

// Initial values are:
int adchans = 2;
int dachans = 2;

int graphscreen = 0;		// 0: 4 parts


int loadfile    = 0;
int paused      = 1;
int dofft1      = 0;
int dofft2      = 0;

// To store Load Data
int lData1[1024] = { 0, 0, 0, 0, 0, 0, 0, 0 };
int lData2[1024] = { 0, 0, 0, 0, 0, 0, 0, 0 };
int loadfile_size       = 256;
int loadfile_numchans   = 1;
int loadfile_wperiod    = 1000;		// msec
int loadfile_continuous = 1;

// To store info of display data
struct Params
{
	void *buf1;
	void *buf2;
	int   bufsize1;
	int   bufsize2;
};

struct Params locpar = { lData1, lData2, 8, 8 };

struct Params *p = &locpar;

extern "C" {
void function0(HWND hWnd);
void function1(HWND hWnd);
void function2(HWND hWnd);
void function3(HWND hWnd);
void function4(HWND hWnd);
void function5(HWND hWnd);/* added 5/3/03 */
extern int slotnumber;
extern int stopthread;
extern float ddsfreq;
extern int controlsem;
extern int fftwindow;
};



void DrawGraph(HWND hWnd, HDC hdc, void *ch1data, void *ch2data, int size1, int size2);

// Foward declarations of functions included in this code module:
ATOM				MyRegisterClass(HINSTANCE hInstance);
BOOL				InitInstance(HINSTANCE, int);
LRESULT CALLBACK	WndProc(HWND, UINT, WPARAM, LPARAM);
LRESULT CALLBACK	About(HWND, UINT, WPARAM, LPARAM);

int APIENTRY WinMain(HINSTANCE hInstance,
                     HINSTANCE hPrevInstance,
                     LPSTR     lpCmdLine,
                     int       nCmdShow)
{
 	// TODO: Place code here.
	MSG msg;
	HACCEL hAccelTable;

	// Initialize global strings
	LoadString(hInstance, IDS_APP_TITLE, szTitle, MAX_LOADSTRING);
	LoadString(hInstance, IDC_HEGRAPH, szWindowClass, MAX_LOADSTRING);
	MyRegisterClass(hInstance);

	// Perform application initialization:
	if (!InitInstance (hInstance, nCmdShow)) 
	{
		return FALSE;
	}

	hAccelTable = LoadAccelerators(hInstance, (LPCTSTR)IDC_HEGRAPH);

	// Main message loop:
	while (GetMessage(&msg, NULL, 0, 0)) 
	{
		if (!TranslateAccelerator(msg.hwnd, hAccelTable, &msg)) 
		{
			TranslateMessage(&msg);
			DispatchMessage(&msg);
		}
	}

	return msg.wParam;
}



//
//  FUNCTION: MyRegisterClass()
//
//  PURPOSE: Registers the window class.
//
//  COMMENTS:
//
//    This function and its usage is only necessary if you want this code
//    to be compatible with Win32 systems prior to the 'RegisterClassEx'
//    function that was added to Windows 95. It is important to call this function
//    so that the application will get 'well formed' small icons associated
//    with it.
//
ATOM MyRegisterClass(HINSTANCE hInstance)
{
	WNDCLASSEX wcex;

	wcex.cbSize = sizeof(WNDCLASSEX); 

	wcex.style			= CS_HREDRAW | CS_VREDRAW;
	wcex.lpfnWndProc	= (WNDPROC)WndProc;
	wcex.cbClsExtra		= 0;
	wcex.cbWndExtra		= 0;
	wcex.hInstance		= hInstance;
	wcex.hIcon			= LoadIcon(hInstance, (LPCTSTR)IDI_HEGRAPH);
	wcex.hCursor		= LoadCursor(NULL, IDC_ARROW);
	wcex.hbrBackground	= (HBRUSH)(COLOR_WINDOW+1);
	wcex.lpszMenuName	= (LPCSTR)IDC_HEGRAPH;
	wcex.lpszClassName	= szWindowClass;
	wcex.hIconSm		= LoadIcon(wcex.hInstance, (LPCTSTR)IDI_SMALL);

	return RegisterClassEx(&wcex);
}

//
//   FUNCTION: InitInstance(HANDLE, int)
//
//   PURPOSE: Saves instance handle and creates main window
//
//   COMMENTS:
//
//        In this function, we save the instance handle in a global variable and
//        create and display the main program window.
//
BOOL InitInstance(HINSTANCE hInstance, int nCmdShow)
{
   HWND hWnd;

   hInst = hInstance; // Store instance handle in our global variable

   hWnd = CreateWindow(szWindowClass, szTitle, WS_OVERLAPPEDWINDOW,
      CW_USEDEFAULT, 0, CW_USEDEFAULT, 0, NULL, NULL, hInstance, NULL);

   if (!hWnd)
   {
      return FALSE;
   }

   ShowWindow(hWnd, nCmdShow);
   UpdateWindow(hWnd);

   return TRUE;
}

static char filename[256]  = { "" };
static char titlename[256] = { "" };

BOOL LoadFile(HWND hWnd, char *fname, char *tname)
{
	OPENFILENAME data;

	if (stopthread==0)
	{
		MessageBox(hWnd, "Sorry, can only do a Load File if no data is being generated (select File->Stop first).", "Load File", MB_OK);
		return FALSE;
	}
	if (loadfile==1)
	{
		MessageBox(hWnd, "Sorry, cannot do a Load File: there's already a Load File in progress (select File->Stop first).", "Load File", MB_OK);
		return FALSE;
	}

	memset((void *)&data, 0, sizeof(OPENFILENAME));
	data.lStructSize    = sizeof(OPENFILENAME);
	data.hwndOwner      = hWnd;
	data.lpstrFilter    = TEXT("DA Data Files (*.dat)\0*.dat\0\0\0");
	data.lpstrFile      = fname;
	data.nMaxFile       = 256;
	data.lpstrFileTitle = tname;
	data.nMaxFileTitle  = 256;
	data.Flags          = OFN_CREATEPROMPT;
	data.lpstrDefExt    = TEXT("dat");

	return GetOpenFileName(&data);
}

BOOL SaveFile(HWND hWnd, char *fname, char *tname)
{
	OPENFILENAME data;

	memset((void *)&data, 0, sizeof(OPENFILENAME));
	data.lStructSize    = sizeof(OPENFILENAME);
	data.hwndOwner      = hWnd;
	data.lpstrFilter    = TEXT("AD Data Files (*.dat)\0*.dat\0\0\0");
	data.lpstrFile      = fname;
	data.nMaxFile       = 256;
	data.lpstrFileTitle = tname;
	data.nMaxFileTitle  = 256;
	data.Flags          = OFN_CREATEPROMPT;
	data.lpstrDefExt    = TEXT("dat");

	return GetSaveFileName(&data);
}

void Start(HWND hWnd, HDC hdc)
{
//	int i;
//
//	// Capture and display
//	for (i=0; i<SIZE; i++)
//	{
//		data[i] = 100.0+100.0*sin(((float)i)/6.28);
//	}
//	DrawGraph(hWnd, hdc, data, data, SIZE);
}

LRESULT CALLBACK ADSelect(HWND hDlg, UINT message, WPARAM wParam, LPARAM lParam)
{
	int  wmId, wmEvent;

	switch (message)
	{
		case WM_INITDIALOG:
				if (adchans==0)
					CheckRadioButton(hDlg, IDC_AD0, IDC_AD2, IDC_AD0);
				else
				if (adchans==1)
					CheckRadioButton(hDlg, IDC_AD0, IDC_AD2, IDC_AD1);
				else
					CheckRadioButton(hDlg, IDC_AD0, IDC_AD2, IDC_AD2);
				break;

		case WM_COMMAND:
			wmId    = LOWORD(wParam); 
			wmEvent = HIWORD(wParam); 
			switch (wmId)
			{
			case IDOK     :
				adchans=2;
				if (IsDlgButtonChecked(hDlg, IDC_AD0)==BST_CHECKED) adchans=0;
				if (IsDlgButtonChecked(hDlg, IDC_AD1)==BST_CHECKED) adchans=1;
				EndDialog(hDlg, 1);
				return TRUE;

			case IDCANCEL :
				EndDialog(hDlg, 0);
				return TRUE;

			default : return FALSE;
			}
			break;
		default:
		    return FALSE;
	}
    return FALSE;
}

LRESULT CALLBACK DASelect(HWND hDlg, UINT message, WPARAM wParam, LPARAM lParam)
{
	int  wmId, wmEvent;

	switch (message)
	{
		case WM_INITDIALOG:
				if (dachans==0)
					CheckRadioButton(hDlg, IDC_DA0, IDC_DA2, IDC_DA0);
				else
				if (dachans==1)
					CheckRadioButton(hDlg, IDC_DA0, IDC_DA2, IDC_DA1);
				else
					CheckRadioButton(hDlg, IDC_DA0, IDC_DA2, IDC_DA2);
				break;

		case WM_COMMAND:
			wmId    = LOWORD(wParam); 
			wmEvent = HIWORD(wParam); 
			switch (wmId)
			{
			case IDOK     :
				dachans=2;
				if (IsDlgButtonChecked(hDlg, IDC_DA0)==BST_CHECKED) dachans=0;
				if (IsDlgButtonChecked(hDlg, IDC_DA1)==BST_CHECKED) dachans=1;
				EndDialog(hDlg, 1);
				return TRUE;

			case IDCANCEL :
				EndDialog(hDlg, 0);
				return TRUE;

			default : return FALSE;
			}
			break;
		default:
		    return FALSE;
	}
    return FALSE;
}

struct graphdata
{
	int autoscale;
	int data_type;
	int min_y_value;
	int max_y_value;
	int hex;
};

int htol(char *str, int radix)
{
	int i=0;
	int n=0;
	int sign=1;

	while (str[i])
	{
		switch (tolower(str[i]))
		{
		case '-': sign=-1; break;
		case '0': n=n*radix+ 0; break;
		case '1': if (radix> 0) n=n*radix+ 1; else return sign*n;
				  break;
		case '2': if (radix> 2) n=n*radix+ 2; else return sign*n;
			      break;
		case '3': if (radix> 3) n=n*radix+ 3; else return sign*n;
			      break;
		case '4': if (radix> 4) n=n*radix+ 4; else return sign*n;
			      break;
		case '5': if (radix> 5) n=n*radix+ 5; else return sign*n;
			      break;
		case '6': if (radix> 6) n=n*radix+ 6; else return sign*n;
			      break;
		case '7': if (radix> 7) n=n*radix+ 7; else return sign*n;
			      break;
		case '8': if (radix> 8) n=n*radix+ 8; else return sign*n;
			      break;
		case '9': if (radix> 9) n=n*radix+ 9; else return sign*n;
			      break;
		case 'a': if (radix>10) n=n*radix+10; else return sign*n;
			      break;
		case 'b': if (radix>11) n=n*radix+11; else return sign*n;
			      break;
		case 'c': if (radix>12) n=n*radix+12; else return sign*n;
			      break;
		case 'd': if (radix>13) n=n*radix+13; else return sign*n;
			      break;
		case 'e': if (radix>14) n=n*radix+14; else return sign*n;
			      break;
		case 'f': if (radix>15) n=n*radix+15; else return sign*n;
			      break;
		default : return sign*n;
		}
		i++;
	}
	return sign*n;
}

void ltoh(int val, char *str, int radix)
{
	int  sign=0, i=0;
	int  j, digit;
	char lstr[32];

	if (val==0)
	{
		str[0]='0';
		str[1]= 0 ;
		return;
	}

	if (val<0)
	{
		val  = -val;
		sign = 1;
	}

	while (val)
	{
		digit = val%radix;
		val   = val/radix;
		switch (digit)
		{
		case 0x0: lstr[i++] = '0'; break;
		case 0x1: lstr[i++] = '1'; break;
		case 0x2: lstr[i++] = '2'; break;
		case 0x3: lstr[i++] = '3'; break;
		case 0x4: lstr[i++] = '4'; break;
		case 0x5: lstr[i++] = '5'; break;
		case 0x6: lstr[i++] = '6'; break;
		case 0x7: lstr[i++] = '7'; break;
		case 0x8: lstr[i++] = '8'; break;
		case 0x9: lstr[i++] = '9'; break;
		case 0xa: lstr[i++] = 'a'; break;
		case 0xb: lstr[i++] = 'b'; break;
		case 0xc: lstr[i++] = 'c'; break;
		case 0xd: lstr[i++] = 'd'; break;
		case 0xe: lstr[i++] = 'e'; break;
		case 0xf: lstr[i++] = 'f'; break;
		default : lstr[i++] =  0 ; return;
		}
	}
	if (sign)
	{
		str[0]='-';
		for (j=0; j<i; j++)
		{
			str[j+1] = lstr[i-j-1];
		}
		str[j+1] = 0;
	}
	else
	{
		for (j=0; j<i; j++)
		{
			str[j  ] = lstr[i-j-1];
		}
		str[j  ] = 0;
	}
}
/*  altered 5/3/03 */
/*struct graphdata ChGraphData[2] = { { 0, 1, -0x7ff, 0x7ff, 1 }, { 0, 1, -0x7ff, 0x7ff, 1 } };*/
struct graphdata ChGraphData[2] = { { 0, 1, -0x1fff, 0x1fff, 1 }, { 0, 1, -0x1fff, 0x1fff, 1 } };

LRESULT CALLBACK Ch1Graph(HWND hDlg, UINT message, WPARAM wParam, LPARAM lParam)
{
	int		wmId, wmEvent;
	int		min, max;
	char	str[256];

	switch (message)
	{
		case WM_INITDIALOG:
				switch (ChGraphData[0].data_type)
				{
				case 1 : CheckRadioButton(hDlg, IDC_SIGNEDINT, IDC_UNSIGNEDSHORT, IDC_SIGNEDSHORT  );
						 break;
				case 2 : CheckRadioButton(hDlg, IDC_SIGNEDINT, IDC_UNSIGNEDSHORT, IDC_UNSIGNEDINT  );
						 break;
				case 3 : CheckRadioButton(hDlg, IDC_SIGNEDINT, IDC_UNSIGNEDSHORT, IDC_UNSIGNEDSHORT);
						 break;
				default: CheckRadioButton(hDlg, IDC_SIGNEDINT, IDC_UNSIGNEDSHORT, IDC_SIGNEDINT    );
						 break;
				}
				if (ChGraphData[0].autoscale)
					CheckRadioButton(hDlg, IDC_AUTOSCALE_ON, IDC_AUTOSCALE_OFF, IDC_AUTOSCALE_ON);
				else
					CheckRadioButton(hDlg, IDC_AUTOSCALE_ON, IDC_AUTOSCALE_OFF, IDC_AUTOSCALE_OFF);

				if (ChGraphData[0].hex)
				{
					CheckDlgButton  (hDlg, IDC_HEX, BST_CHECKED);
					ltoh(ChGraphData[0].max_y_value, str, 16);
					SetDlgItemText(hDlg, IDC_MAXYVALUE, str);
					ltoh(ChGraphData[0].min_y_value, str, 16);
					SetDlgItemText(hDlg, IDC_DCVALUE, str);
				}
				else
				{
					CheckDlgButton  (hDlg, IDC_HEX, BST_UNCHECKED);
					_itoa(ChGraphData[0].max_y_value, str, 10);
					SetDlgItemText(hDlg, IDC_MAXYVALUE, str);
					_itoa(ChGraphData[0].min_y_value, str, 10);
					SetDlgItemText(hDlg, IDC_DCVALUE, str);
				}
				break;

		case WM_COMMAND:
			wmId    = LOWORD(wParam); 
			wmEvent = HIWORD(wParam); 
			switch (wmId)
			{
			case IDC_HEX  :
				if (ChGraphData[0].hex)
				{
					/* Retrieve hex values */
					GetDlgItemText(hDlg, IDC_DCVALUE, str, 64);
					min    = htol(str, 16);
					GetDlgItemText(hDlg, IDC_MAXYVALUE, str, 64);
					max = htol(str, 16);
					/* swap radix */
					ChGraphData[0].hex = 0;
					/* recalculate values into dec */
					_itoa(max, str, 10);
					SetDlgItemText(hDlg, IDC_MAXYVALUE, str);
					_itoa(min, str, 10);
					SetDlgItemText(hDlg, IDC_DCVALUE, str);
				}
				else
				{
					/* Retrieve dec values */
					GetDlgItemText(hDlg, IDC_DCVALUE, str, 64);
					min = atoi(str);
					GetDlgItemText(hDlg, IDC_MAXYVALUE, str, 64);
					max = atoi(str);
					/* swap radix */
					ChGraphData[0].hex = 1;
					/* recalculate values into hex */
					ltoh(max, str, 16);
					SetDlgItemText(hDlg, IDC_MAXYVALUE, str);
					ltoh(min, str, 16);
					SetDlgItemText(hDlg, IDC_DCVALUE, str);
				}
				break;

			case IDOK     :
				if (IsDlgButtonChecked(hDlg, IDC_SIGNEDINT    )==BST_CHECKED) ChGraphData[0].data_type=0;
				if (IsDlgButtonChecked(hDlg, IDC_SIGNEDSHORT  )==BST_CHECKED) ChGraphData[0].data_type=1;
				if (IsDlgButtonChecked(hDlg, IDC_UNSIGNEDINT  )==BST_CHECKED) ChGraphData[0].data_type=2;
				if (IsDlgButtonChecked(hDlg, IDC_UNSIGNEDSHORT)==BST_CHECKED) ChGraphData[0].data_type=3;
				if (IsDlgButtonChecked(hDlg, IDC_AUTOSCALE_ON )==BST_CHECKED) ChGraphData[0].autoscale=1;
				if (IsDlgButtonChecked(hDlg, IDC_AUTOSCALE_OFF)==BST_CHECKED) ChGraphData[0].autoscale=0;
				if (ChGraphData[0].hex)
				{
					GetDlgItemText(hDlg, IDC_DCVALUE, str, 64);
					ChGraphData[0].min_y_value = htol(str, 16);
					GetDlgItemText(hDlg, IDC_MAXYVALUE, str, 64);
					ChGraphData[0].max_y_value = htol(str, 16);
				}
				else
				{
					GetDlgItemText(hDlg, IDC_DCVALUE, str, 64);
					ChGraphData[0].min_y_value = atoi(str);
					GetDlgItemText(hDlg, IDC_MAXYVALUE, str, 64);
					ChGraphData[0].max_y_value = atoi(str);
				}
				EndDialog(hDlg, 1);
				return TRUE;

			case IDCANCEL :
				EndDialog(hDlg, 0);
				return TRUE;

			default : return FALSE;
			}
			break;
		default:
		    return FALSE;
	}
    return FALSE;
}

LRESULT CALLBACK Ch2Graph(HWND hDlg, UINT message, WPARAM wParam, LPARAM lParam)
{
	int		wmId, wmEvent;
	int		min, max;
	char	str[256];

	switch (message)
	{
		case WM_INITDIALOG:
				switch (ChGraphData[1].data_type)
				{
				case 1 : CheckRadioButton(hDlg, IDC_SIGNEDINT, IDC_UNSIGNEDSHORT, IDC_SIGNEDSHORT  );
						 break;
				case 2 : CheckRadioButton(hDlg, IDC_SIGNEDINT, IDC_UNSIGNEDSHORT, IDC_UNSIGNEDINT  );
						 break;
				case 3 : CheckRadioButton(hDlg, IDC_SIGNEDINT, IDC_UNSIGNEDSHORT, IDC_UNSIGNEDSHORT);
						 break;
				default: CheckRadioButton(hDlg, IDC_SIGNEDINT, IDC_UNSIGNEDSHORT, IDC_SIGNEDINT    );
						 break;
				}
				if (ChGraphData[1].autoscale)
					CheckRadioButton(hDlg, IDC_AUTOSCALE_ON, IDC_AUTOSCALE_OFF, IDC_AUTOSCALE_ON);
				else
					CheckRadioButton(hDlg, IDC_AUTOSCALE_ON, IDC_AUTOSCALE_OFF, IDC_AUTOSCALE_OFF);

				if (ChGraphData[1].hex)
				{
					CheckDlgButton  (hDlg, IDC_HEX, BST_CHECKED);
					ltoh(ChGraphData[1].min_y_value, str, 16);
					SetDlgItemText(hDlg, IDC_DCVALUE, str);
					ltoh(ChGraphData[1].max_y_value, str, 16);
					SetDlgItemText(hDlg, IDC_MAXYVALUE, str);
				}
				else
				{
					CheckDlgButton  (hDlg, IDC_HEX, BST_UNCHECKED);
					_itoa(ChGraphData[1].min_y_value, str, 10);
					SetDlgItemText(hDlg, IDC_DCVALUE, str);
					_itoa(ChGraphData[1].max_y_value, str, 10);
					SetDlgItemText(hDlg, IDC_MAXYVALUE, str);
				}
				break;

		case WM_COMMAND:
			wmId    = LOWORD(wParam); 
			wmEvent = HIWORD(wParam); 
			switch (wmId)
			{
			case IDC_HEX  :
				if (ChGraphData[1].hex)
				{
					/* Retrieve hex values */
					GetDlgItemText(hDlg, IDC_DCVALUE, str, 64);
					min    = htol(str, 16);
					GetDlgItemText(hDlg, IDC_MAXYVALUE, str, 64);
					max = htol(str, 16);
					/* swap radix */
					ChGraphData[1].hex = 0;
					/* recalculate values into dec */
					_itoa(max, str, 10);
					SetDlgItemText(hDlg, IDC_MAXYVALUE, str);
					_itoa(min, str, 10);
					SetDlgItemText(hDlg, IDC_DCVALUE, str);
				}
				else
				{
					/* Retrieve dec values */
					GetDlgItemText(hDlg, IDC_DCVALUE, str, 64);
					min = atoi(str);
					GetDlgItemText(hDlg, IDC_MAXYVALUE, str, 64);
					max = atoi(str);
					/* swap radix */
					ChGraphData[1].hex = 1;
					/* recalculate values into hex */
					ltoh(max, str, 16);
					SetDlgItemText(hDlg, IDC_MAXYVALUE, str);
					ltoh(min, str, 16);
					SetDlgItemText(hDlg, IDC_DCVALUE, str);
				}
				break;

			case IDOK     :
				if (IsDlgButtonChecked(hDlg, IDC_SIGNEDINT    )==BST_CHECKED) ChGraphData[1].data_type=0;
				if (IsDlgButtonChecked(hDlg, IDC_SIGNEDSHORT  )==BST_CHECKED) ChGraphData[1].data_type=1;
				if (IsDlgButtonChecked(hDlg, IDC_UNSIGNEDINT  )==BST_CHECKED) ChGraphData[1].data_type=2;
				if (IsDlgButtonChecked(hDlg, IDC_UNSIGNEDSHORT)==BST_CHECKED) ChGraphData[1].data_type=3;
				if (IsDlgButtonChecked(hDlg, IDC_AUTOSCALE_ON )==BST_CHECKED) ChGraphData[1].autoscale=1;
				if (IsDlgButtonChecked(hDlg, IDC_AUTOSCALE_OFF)==BST_CHECKED) ChGraphData[1].autoscale=0;
				if (ChGraphData[1].hex)
				{
					GetDlgItemText(hDlg, IDC_MAXYVALUE, str, 64);
					ChGraphData[1].max_y_value = htol(str, 16);
					GetDlgItemText(hDlg, IDC_DCVALUE, str, 64);
					ChGraphData[1].min_y_value = htol(str, 16);
				}
				else
				{
					GetDlgItemText(hDlg, IDC_MAXYVALUE, str, 64);
					ChGraphData[1].max_y_value = atoi(str);
					GetDlgItemText(hDlg, IDC_DCVALUE, str, 64);
					ChGraphData[1].min_y_value = atoi(str);
				}
				EndDialog(hDlg, 1);
				return TRUE;

			case IDCANCEL :
				EndDialog(hDlg, 0);
				return TRUE;

			default : return FALSE;
			}
			break;
		default:
		    return FALSE;
	}
    return FALSE;
}

void CheckCh1FFT(HWND hWnd, int x)
{
	HMENU hMenu, hGraph, hCh1FFT;

	hMenu   = GetMenu(hWnd);
	hGraph  = GetSubMenu(hMenu, 2);
	hCh1FFT = GetSubMenu(hGraph, 2);

	switch (x)
	{
		case 0 : CheckMenuItem(hCh1FFT, IDM_CH1FFT_ON , MF_UNCHECKED);
		         CheckMenuItem(hCh1FFT, IDM_CH1FFT_OFF, MF_CHECKED  );
				 break;
		default: CheckMenuItem(hCh1FFT, IDM_CH1FFT_ON , MF_CHECKED  );
		         CheckMenuItem(hCh1FFT, IDM_CH1FFT_OFF, MF_UNCHECKED);
				 break;
	}
}

void CheckCh2FFT(HWND hWnd, int x)
{
	HMENU hMenu, hGraph, hCh2FFT;

	hMenu   = GetMenu(hWnd);
	hGraph  = GetSubMenu(hMenu, 2);
	hCh2FFT = GetSubMenu(hGraph, 3);

	switch (x)
	{
		case 0 : CheckMenuItem(hCh2FFT, IDM_CH2FFT_ON , MF_UNCHECKED);
		         CheckMenuItem(hCh2FFT, IDM_CH2FFT_OFF, MF_CHECKED  );
				 break;
		default: CheckMenuItem(hCh2FFT, IDM_CH2FFT_ON , MF_CHECKED  );
		         CheckMenuItem(hCh2FFT, IDM_CH2FFT_OFF, MF_UNCHECKED);
				 break;
	}
}

LRESULT CALLBACK LoadFileOptions(HWND hDlg, UINT message, WPARAM wParam, LPARAM lParam)
{
	int		wmId, wmEvent;
	char	str[256];

	switch (message)
	{
		case WM_INITDIALOG:
				if (loadfile_numchans==1)
					CheckRadioButton(hDlg, IDC_LOADFILE1CH, IDC_LOADFILE2CH, IDC_LOADFILE1CH);
				else
					CheckRadioButton(hDlg, IDC_LOADFILE1CH, IDC_LOADFILE2CH, IDC_LOADFILE2CH);

				_itoa(loadfile_size, str, 10);
				SetDlgItemText(hDlg, IDC_LOADFILESIZE, str);

				if (loadfile_continuous)
					CheckRadioButton(hDlg, IDC_LOADFILECONT, IDC_LOADFILEASK, IDC_LOADFILECONT);
				else
					CheckRadioButton(hDlg, IDC_LOADFILECONT, IDC_LOADFILEASK, IDC_LOADFILEASK);

				_itoa(loadfile_wperiod, str, 10);
				SetDlgItemText(hDlg, IDC_LOADFILEPERIOD, str);
				break;

		case WM_COMMAND:
			wmId    = LOWORD(wParam); 
			wmEvent = HIWORD(wParam); 
			switch (wmId)
			{
			case IDOK     :
				loadfile_numchans   = 1;
				if (IsDlgButtonChecked(hDlg, IDC_LOADFILE2CH)==BST_CHECKED) loadfile_numchans   = 2;

				GetDlgItemText(hDlg, IDC_LOADFILESIZE, str, 64);
				loadfile_size = atoi(str);
				
				loadfile_continuous = 1;
				if (IsDlgButtonChecked(hDlg, IDC_LOADFILEASK)==BST_CHECKED) loadfile_continuous = 0;
				
				GetDlgItemText(hDlg, IDC_LOADFILEPERIOD, str, 64);
				loadfile_wperiod = atoi(str);
				EndDialog(hDlg, 1);
				return TRUE;

			case IDCANCEL :
				EndDialog(hDlg, 0);
				return TRUE;

			default : return FALSE;
			}
			break;
		default:
		    return FALSE;
	}
    return FALSE;
}

LRESULT CALLBACK SlotNoOptions(HWND hDlg, UINT message, WPARAM wParam, LPARAM lParam)
{
	int		wmId, wmEvent;

	switch (message)
	{
		case WM_INITDIALOG:
				if (slotnumber==1)
					CheckRadioButton(hDlg, IDC_SLOT1, IDC_SLOT4, IDC_SLOT1);
				else if (slotnumber==2)
					CheckRadioButton(hDlg, IDC_SLOT1, IDC_SLOT4, IDC_SLOT2);
				else if (slotnumber==3)
					CheckRadioButton(hDlg, IDC_SLOT1, IDC_SLOT4, IDC_SLOT3);
				else if (slotnumber==4)
					CheckRadioButton(hDlg, IDC_SLOT1, IDC_SLOT4, IDC_SLOT4);
				break;

		case WM_COMMAND:
			wmId    = LOWORD(wParam); 
			wmEvent = HIWORD(wParam); 
			switch (wmId)
			{
			case IDOK     :
				if (IsDlgButtonChecked(hDlg, IDC_SLOT1)==BST_CHECKED) slotnumber   = 1;
				if (IsDlgButtonChecked(hDlg, IDC_SLOT2)==BST_CHECKED) slotnumber   = 2;
				if (IsDlgButtonChecked(hDlg, IDC_SLOT3)==BST_CHECKED) slotnumber   = 3;
				if (IsDlgButtonChecked(hDlg, IDC_SLOT4)==BST_CHECKED) slotnumber   = 4;
				EndDialog(hDlg, 1);
				return TRUE;

			case IDCANCEL :
				EndDialog(hDlg, 0);
				return TRUE;

			default : return FALSE;
			}
			break;
		default:
		    return FALSE;
	}
    return FALSE;
}

LRESULT CALLBACK DDSFreq(HWND hDlg, UINT message, WPARAM wParam, LPARAM lParam)
{
	int		wmId, wmEvent;
	char	str[256];

	switch (message)
	{
		case WM_INITDIALOG:
				sprintf(str, "%.4f", ddsfreq);
				SetDlgItemText(hDlg, IDC_DDSFREQ, str);
				break;

		case WM_COMMAND:
			wmId    = LOWORD(wParam); 
			wmEvent = HIWORD(wParam); 
			switch (wmId)
			{
			case IDOK     :
				GetDlgItemText(hDlg, IDC_DDSFREQ, str, 256);
				ddsfreq = atof(str);
				controlsem=2;
				EndDialog(hDlg, 1);
				return TRUE;

			case IDCANCEL :
				EndDialog(hDlg, 0);
				return TRUE;

			default : return FALSE;
			}
			break;
		default:
		    return FALSE;
	}
    return FALSE;
}

LRESULT CALLBACK SelectWindow(HWND hDlg, UINT message, WPARAM wParam, LPARAM lParam)
{
	int		wmId, wmEvent;

	switch (message)
	{
		case WM_INITDIALOG:
				if (fftwindow==0)
					CheckRadioButton(hDlg, IDC_KAISERBESSEL, IDC_RECTANGULAR, IDC_KAISERBESSEL);
				else
					CheckRadioButton(hDlg, IDC_KAISERBESSEL, IDC_RECTANGULAR, IDC_RECTANGULAR);
				break;

		case WM_COMMAND:
			wmId    = LOWORD(wParam); 
			wmEvent = HIWORD(wParam); 
			switch (wmId)
			{
			case IDOK     :
				if (IsDlgButtonChecked(hDlg, IDC_KAISERBESSEL)==BST_CHECKED) fftwindow = 0;
				if (IsDlgButtonChecked(hDlg, IDC_RECTANGULAR )==BST_CHECKED) fftwindow = 1;
				controlsem=3;
				EndDialog(hDlg, 1);
				return TRUE;

			case IDCANCEL :
				EndDialog(hDlg, 0);
				return TRUE;

			default : return FALSE;
			}
			break;
		default:
		    return FALSE;
	}
    return FALSE;
}

// This thread communicates with the DSP board

void __cdecl ThreadServeBoard(void *ptr)
{
	HWND hWnd = (HWND) ptr;
	int p=1;

	while (!stopthread)
	{
		if (paused)
		{
			while (paused)
			{
				Sleep(50);
			}
		}
		else
		{
			function0(hWnd);
		}
	}
	stopthread=1;

	_cexit();			// flush buffers etc.
	_endthread();
}

int StartMyThread(HWND hWnd)
{
	int tid;

	stopthread = 0;
	tid = _beginthread(
						ThreadServeBoard,	/* void( __cdecl *start_address )( void * ),*/
						4096,				/* unsigned stack_size */
						hWnd				/* void *arglist       */
					  );
	if (tid == -1)
	{
		char mess[256];

		switch (errno)
		{
		case EAGAIN: sprintf(mess, "Cannot start thread: too many threads.\n"); break;
		case EINVAL: sprintf(mess, "Cannot start thread: invalid argument.\n"); break;
		default    : sprintf(mess, "Cannot start thread: unknown error %d.\n"); break;
		}
		MessageBox(hWnd, mess, "API thread problem", MB_OK);
		return 0;
	}

	return 1;
}

int SaveData(HWND hWnd, FILE *f, char *fname, void *data, int size, int datatype)
{
	int i;

	for (i=0; i<size; i++)
	{
		fprintf(f, "%d\n", ((int *)data)[i]);
		if (ferror(f))
		{
			char msg[256];
			sprintf("Sorry, error writing file %s.", fname);
			MessageBox(hWnd, msg, "Save File", MB_OK);
			return 0;
		}
	}
	return 1;
}

extern int olddata[4][1024];
extern int oldsize[4];

int SaveMyFile(HWND hWnd, char *fname)
{
	FILE *f;

	f = fopen(fname, "w");
	if (f==NULL)
	{
		char msg[256];
		sprintf("Sorry, unable to open file %s.", fname);
		MessageBox(hWnd, msg, "Save File", MB_OK);
		return 0;
	}

	if (!SaveData(hWnd, f, fname, olddata[0], oldsize[0], ChGraphData[0].data_type))
	{
		fclose(f);
		return 0;
	}
	if (!SaveData(hWnd, f, fname, olddata[1], oldsize[0], ChGraphData[1].data_type))
	{
		fclose(f);
		return 0;
	}

	fclose(f);

	return 1;
}

int LoadData(HWND hWnd, FILE *f, char *fname, void *data, int *size, int datatype)
{
	int i=0;

	while (i<*size)
	{
		fscanf(f, "%d\n", &((int *)data)[i]);
		if (ferror(f))
		{
			char msg[256];
			sprintf("Sorry, error reading file %s.", fname);
			MessageBox(hWnd, msg, "Save File", MB_OK);
			return 0;
		}
		i++;
		if (feof(f)) { *size = i; return 1; }
	}
	return 1;
}

int LoadMyFile(HWND hWnd, char *fname)
{
	FILE *f;
	int   size1=0, size2=0, more;

	f = fopen(fname, "r");
	if (f==NULL)
	{
		char msg[256];
		sprintf("Sorry, unable to open file %s.", fname);
		MessageBox(hWnd, msg, "Save File", MB_OK);
		return 0;
	}

	more = 1;
	while (more&&loadfile)
	{
		size1 = loadfile_size;		// maximum we can read
		if (!LoadData(hWnd, f, fname, lData1, &size1,  ChGraphData[0].data_type))
		{
			fclose(f);	
			return 0;
		}

		if (loadfile_numchans>1)
		{
			size2 = loadfile_size;		// maximum we can read
			if (!LoadData(hWnd, f, fname, lData2, &size2,  ChGraphData[0].data_type))
			{
				fclose(f);	
				return 0;
			}
		}
		if ((size1>4)||(size2>4))
		{
			locpar.buf1     = lData1;
			locpar.bufsize1 = size1;
			locpar.buf2     = lData2;
			locpar.bufsize2 = size2;
			SendMessage(hWnd, HE_UPDATEGRAPH, (unsigned int) &locpar, 0);
		}
		if (loadfile_numchans==1)
		{
			if (size1<loadfile_size)
			{
				more = 0;
			}
		}
		else
		{
			if ((size1<loadfile_size)||(size2<loadfile_size))
			{
				more = 0;
			}
		}

		if (loadfile_continuous)
		{
			Sleep(loadfile_wperiod);
		}
		else
		{
			switch (MessageBox(hWnd, "Display next buffer?", "Load and display file buffer", MB_OKCANCEL))
			{
			case IDCANCEL: more = 0; break;
			default      :           break;
			}
		}
	}

	return 1;
}

void __cdecl ThreadLoadFile(void *ptr)
{
	HWND hWnd = (HWND) ptr;

	LoadMyFile(hWnd, filename);
	loadfile=0;

	_cexit();			// flush buffers etc.
	_endthread();
}

int StartLoadFile(HWND hWnd)
{
	int tid;

	tid = _beginthread(
						ThreadLoadFile,		/* void( __cdecl *start_address )( void * ),*/
						4096,				/* unsigned stack_size */
						hWnd				/* void *arglist       */
					  );
	if (tid == -1)
	{
		char mess[256];

		switch (errno)
		{
		case EAGAIN: sprintf(mess, "Cannot start thread: too many threads.\n"); break;
		case EINVAL: sprintf(mess, "Cannot start thread: invalid argument.\n"); break;
		default    : sprintf(mess, "Cannot start thread: unknown error %d.\n"); break;
		}
		MessageBox(hWnd, mess, "Load File thread problem", MB_OK);
		return 0;
	}

	return 1;
}

//
//  FUNCTION: WndProc(HWND, unsigned, WORD, LONG)
//
//  PURPOSE:  Processes messages for the main window.
//
//  WM_COMMAND	- process the application menu
//  WM_PAINT	- Paint the main window
//  WM_DESTROY	- post a quit message and return
//
//
LRESULT CALLBACK WndProc(HWND hWnd, UINT message, WPARAM wParam, LPARAM lParam)
{
	int wmId, wmEvent;
	PAINTSTRUCT ps;
	HDC hdc;
	TCHAR szHello[MAX_LOADSTRING];
	LoadString(hInst, IDS_HELLO, szHello, MAX_LOADSTRING);

	switch (message) 
	{
		case WM_COMMAND:
			wmId    = LOWORD(wParam); 
			wmEvent = HIWORD(wParam); 
			// Parse the menu selections:
			switch (wmId)
			{
				case IDM_ABOUT:
				   DialogBox(hInst, (LPCTSTR)IDD_ABOUTBOX, hWnd, (DLGPROC)About);
				   break;

				case IDM_LOAD:
					if (LoadFile(hWnd, filename, titlename))
					{
						loadfile = 1;
						StartLoadFile(hWnd);
					}
					break;

				case IDM_SAVE:
					if (SaveFile(hWnd, filename, titlename))
					{
						SaveMyFile(hWnd, filename);
					}
					break;

				case IDM_START:
					if(stopthread==1)
					{
					if (StartMyThread(hWnd))
					{
						paused = 0;
					}
					}
					break;

				case IDM_STOP:
					stopthread = 1;
					loadfile   = 0;
					break;

				case IDM_ADCHAN:
					DialogBox(hInst, (LPCTSTR)IDD_ADCHAN, hWnd, (DLGPROC)ADSelect);
					break;

				case IDM_DACHAN:
					DialogBox(hInst, (LPCTSTR)IDD_DACHAN, hWnd, (DLGPROC)DASelect);
					break;

				case IDM_LOADFILE:
					DialogBox(hInst, (LPCTSTR)IDD_LOADFILE, hWnd, (DLGPROC)LoadFileOptions);
					break;

				case IDM_SLOTNO:
					DialogBox(hInst, (LPCTSTR)IDD_SLOTNO, hWnd, (DLGPROC)SlotNoOptions);
					break;

				case IDM_DDSFREQ:
					DialogBox(hInst, (LPCTSTR)IDD_DDSFREQ, hWnd, (DLGPROC)DDSFreq);
					break;

				case IDM_WINDOW:
					DialogBox(hInst, (LPCTSTR)IDD_WINDOW, hWnd, (DLGPROC)SelectWindow);
					break;

				case IDM_CH1GRAPH:
					DialogBox(hInst, (LPCTSTR)IDD_CH1DATA, hWnd, (DLGPROC)Ch1Graph);
					InvalidateRect(hWnd, NULL, TRUE);
					break;

				case IDM_CH2GRAPH:
					DialogBox(hInst, (LPCTSTR)IDD_CH2DATA, hWnd, (DLGPROC)Ch2Graph);
					InvalidateRect(hWnd, NULL, TRUE);
					break;

				case IDM_CH1FFT_ON:
					dofft1 = 1;
					CheckCh1FFT(hWnd, 1);
					InvalidateRect(hWnd, NULL, TRUE);
					break;

				case IDM_CH1FFT_OFF:
					dofft1 = 0;
					CheckCh1FFT(hWnd, 0);
					InvalidateRect(hWnd, NULL, TRUE);
					break;

				case IDM_CH2FFT_ON:
					dofft2 = 1;
					CheckCh2FFT(hWnd, 1);
					InvalidateRect(hWnd, NULL, TRUE);
					break;

				case IDM_CH2FFT_OFF:
					dofft2 = 0;
					CheckCh2FFT(hWnd, 0);
					InvalidateRect(hWnd, NULL, TRUE);
					break;

				case IDM_F1:
					function1(hWnd);
					break;

				case IDM_F2:
					function2(hWnd);
					break;

				case IDM_F3:
					function3(hWnd);
					break;

				case IDM_F4:
					function4(hWnd);
					break;
				case IDM_EXIT:
				   DestroyWindow(hWnd);
				   break;

				default:
				   return DefWindowProc(hWnd, message, wParam, lParam);
			}
			break;

		case WM_CREATE:
			CheckCh1FFT(hWnd, dofft1);
			CheckCh2FFT(hWnd, dofft2);
			break;

		case WM_PAINT:
			hdc = BeginPaint(hWnd, &ps);
			// TODO: Add any drawing code here...
//			RECT rt;
//			GetClientRect(hWnd, &rt);
//			DrawText(hdc, szHello, strlen(szHello), &rt, DT_CENTER);
			DrawGraph(hWnd, hdc, p->buf1, p->buf2, p->bufsize1, p->bufsize2);
			EndPaint(hWnd, &ps);
			break;

		case HE_UPDATEGRAPH:
			p   = (struct Params *) wParam;
			hdc = NULL;
			DrawGraph(hWnd, hdc, p->buf1, p->buf2, p->bufsize1, p->bufsize2);
			break;

		case WM_DESTROY:
			PostQuitMessage(0);
			break;
		default:
			return DefWindowProc(hWnd, message, wParam, lParam);
   }
   return 0;
}

// Mesage handler for about box.
LRESULT CALLBACK About(HWND hDlg, UINT message, WPARAM wParam, LPARAM lParam)
{
	switch (message)
	{
		case WM_INITDIALOG:
				return TRUE;

		case WM_COMMAND:
			if (LOWORD(wParam) == IDOK || LOWORD(wParam) == IDCANCEL) 
			{
				EndDialog(hDlg, LOWORD(wParam));
				return TRUE;
			}
			break;
	}
    return FALSE;
}
