#ifdef HAVE_CONFIG_H
#  include <config.h>
#endif

#include <gnome.h>

#include "callbacks.h"
#include "interface.h"
#include "support.h"

#include "settings.h"

GtkWidget *MainWindow = NULL;

extern int stopthread;
extern int main_loop;
extern volatile int data_display;
extern int controlsem;

int  openthefile = 0;
char openfilename[256]; 

void OpenFile_Browse(GtkMenuItem     *menuitem)
{
   GtkWidget *file_selector;
   int        r;

   file_selector = gtk_file_selection_new("File Open: select a file to display data");
   gtk_widget_show(file_selector);
   r = gtk_dialog_run(GTK_DIALOG(file_selector));
   if (r==GTK_RESPONSE_OK)
   {
      GtkWidget  *editbox;
      const char *selected_filename;

      selected_filename = gtk_file_selection_get_filename(GTK_FILE_SELECTION(file_selector));
      strcpy(openfilename, selected_filename);
      openthefile = 1;
   }
   gtk_widget_destroy(file_selector);
}

void
on_open1_activate                      (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{
   if (stopthread) OpenFile_Browse(menuitem);
}

int  savethefile = 0;
char savefilename[256]; 

void SaveFile_Browse(GtkMenuItem     *menuitem)
{
   GtkWidget *file_selector;
   int        r;

   file_selector = gtk_file_selection_new("File Save: select a file to save data");
   gtk_widget_show(file_selector);
   r = gtk_dialog_run(GTK_DIALOG(file_selector));
   if (r==GTK_RESPONSE_OK)
   {
      GtkWidget  *editbox;
      const char *selected_filename;

      selected_filename = gtk_file_selection_get_filename(GTK_FILE_SELECTION(file_selector));
      strcpy(savefilename, selected_filename);
      savethefile = 1;
   }
   gtk_widget_destroy(file_selector);
}

void
on_save1_activate                      (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{
   SaveFile_Browse(menuitem);
}




void
on_quit1_activate                      (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{
   exit(0);
   main_loop  = 0;
   stopthread = 1;
   gtk_main_quit();
}

gboolean
on_window1_delete_event                (GtkWidget       *widget,
                                        GdkEvent        *event,
                                        gpointer         user_data)
{
   exit(0);
   main_loop  = 0;
   stopthread = 1;
   gtk_main_quit();
   return FALSE;
}


void
on_cut1_activate                       (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{

}


void
on_copy1_activate                      (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{

}


void
on_paste1_activate                     (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{

}


void
on_clear1_activate                     (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{

}


void
on_properties1_activate                (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{

}


void
on_preferences1_activate               (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{

}


void
on_about1_activate                     (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{

}

////////////////////////////////////////////////////////////////////////////////
// Drawing Area 1
////////////////////////////////////////////////////////////////////////////////

void DrawGraph(GtkWidget *gDrawArea[4], GdkPixmap *gPixmap[4], void *ch1data, void *ch2data, int size1, int size2);

GdkPixmap *gPixmap[4]  = { NULL, NULL, NULL, NULL };
GdkPixmap *gPixmap1[4] = { NULL, NULL, NULL, NULL };
GdkPixmap *gPixmap2[4] = { NULL, NULL, NULL, NULL };

int update_pixmap   = 0;
int busy            = 0;

void DrawWindow(int *buf1, int bufsize1, int *buf2, int bufsize2)
{
   int i;

   GtkWidget *gDrawArea[4] = { NULL, NULL, NULL, NULL };

   if (MainWindow==NULL) return;

   busy = 1;

   gDrawArea[0] = lookup_widget(MainWindow, "drawingarea1");
   gDrawArea[1] = lookup_widget(MainWindow, "drawingarea2");
   gDrawArea[2] = lookup_widget(MainWindow, "drawingarea3");
   gDrawArea[3] = lookup_widget(MainWindow, "drawingarea4");

   if ((gDrawArea[0] != NULL)&&(gPixmap[0] != NULL))
   {
       gdk_draw_rectangle(gPixmap[0], gDrawArea[0]->style->white_gc,
                          TRUE, 0, 0, gDrawArea[0]->allocation.width, gDrawArea[0]->allocation.height);
   }
   if ((gDrawArea[1] != NULL)&&(gPixmap[1] != NULL))
   {
       gdk_draw_rectangle(gPixmap[1], gDrawArea[1]->style->white_gc,
                          TRUE, 0, 0, gDrawArea[1]->allocation.width, gDrawArea[1]->allocation.height);
   }
   if ((gDrawArea[2] != NULL)&&(gPixmap[2] != NULL))
   {
       gdk_draw_rectangle(gPixmap[2], gDrawArea[2]->style->white_gc,
                          TRUE, 0, 0, gDrawArea[2]->allocation.width, gDrawArea[2]->allocation.height);
   }
   if ((gDrawArea[3] != NULL)&&(gPixmap[3] != NULL))
   {
       gdk_draw_rectangle(gPixmap[3], gDrawArea[3]->style->white_gc,
                          TRUE, 0, 0, gDrawArea[3]->allocation.width, gDrawArea[3]->allocation.height);
   }

   DrawGraph(gDrawArea, gPixmap, buf1, buf2, bufsize1, bufsize2);

   if ((gDrawArea[0] != NULL)&&(gPixmap[0] != NULL))
   {
       gdk_draw_drawable(gDrawArea[0]->window,
                         gDrawArea[0]->style->fg_gc[GTK_WIDGET_STATE (gDrawArea[0])],
                         gPixmap[0],
                         0, 0,
                         0, 0,
                         gDrawArea[0]->allocation.width,gDrawArea[0]->allocation.height);
   }
   if ((gDrawArea[1] != NULL)&&(gPixmap[1] != NULL))
   {
       gdk_draw_drawable(gDrawArea[1]->window,
                         gDrawArea[1]->style->fg_gc[GTK_WIDGET_STATE (gDrawArea[1])],
                         gPixmap[1],
                         0, 0,
                         0, 0,
                         gDrawArea[1]->allocation.width,gDrawArea[1]->allocation.height);
   }
   if ((gDrawArea[2] != NULL)&&(gPixmap[2] != NULL))
   {
       gdk_draw_drawable(gDrawArea[2]->window,
                         gDrawArea[2]->style->fg_gc[GTK_WIDGET_STATE (gDrawArea[2])],
                         gPixmap[2],
                         0, 0,
                         0, 0,
                         gDrawArea[2]->allocation.width,gDrawArea[2]->allocation.height);
   }
   if ((gDrawArea[3] != NULL)&&(gPixmap[3] != NULL))
   {
       gdk_draw_drawable(gDrawArea[3]->window,
                         gDrawArea[3]->style->fg_gc[GTK_WIDGET_STATE (gDrawArea[3])],
                         gPixmap[3],
                         0, 0,
                         0, 0,
                         gDrawArea[3]->allocation.width,gDrawArea[3]->allocation.height);
   }

#if 0
   if (update_pixmap)
   {
      if (gPixmap[0] == gPixmap2[0])
      {
         gPixmap[0] = gPixmap1[0];
//         printf("Updated. Pixmap 1\n");
      }
      else
      {
         gPixmap[0] = gPixmap1[0];
//         printf("Updated. Pixmap 2\n");
      }
      update_pixmap = 0;
   }
#endif

   busy = 0;
}

// Draw Area Generic function ///////////////////////////////////////////////////////////

gboolean
on_drawingarea_configure_event        (GtkWidget         *widget,
                                       GdkEventConfigure *event,
                                       gpointer           user_data,
                                       int                i)
{
   if (MainWindow==NULL) MainWindow = lookup_widget(GTK_WIDGET(widget), "window1");

   if (gPixmap[i] == NULL)
   {
      // First time in this function. Initialise.
      gPixmap1[i] = gdk_pixmap_new(widget->window,
                                   widget->allocation.width,
                                   widget->allocation.height,
                                   -1);

      gdk_draw_rectangle(gPixmap1[i], widget->style->white_gc,
                          TRUE, 0, 0, widget->allocation.width, widget->allocation.height);

      gPixmap[i] = gPixmap1[i];
   }
   else
   {
      if (gPixmap[i] == gPixmap2[i])
      {
          // Re-size pixmap 1
         if (gPixmap1[i]) gdk_pixmap_unref(gPixmap1[i]);

         gPixmap1[i] = gdk_pixmap_new(widget->window,
                                      widget->allocation.width,
                                      widget->allocation.height,
                                      -1);

         gdk_draw_rectangle(gPixmap1[i], widget->style->white_gc,
                            TRUE, 0, 0, widget->allocation.width, widget->allocation.height);
         if (busy) 
         {
            // Tell DrawGraph to change update gPixmap
            update_pixmap = 1;
         }
         else
         {
            gPixmap[i] = gPixmap1[i];
         }
      }
      else
      {
          // Re-size pixmap 2
         if (gPixmap2[i]) gdk_pixmap_unref(gPixmap2[i]);

         gPixmap2[i] = gdk_pixmap_new(widget->window,
                                      widget->allocation.width,
                                      widget->allocation.height,
                                      -1);

         gdk_draw_rectangle(gPixmap2[i], widget->style->white_gc,
                            TRUE, 0, 0, widget->allocation.width, widget->allocation.height);
         if (busy) 
         {
            // Tell DrawGraph to change update gPixmap
            update_pixmap = 1;
         }
         else
         {
            gPixmap[i] = gPixmap2[i];
         }
      }
   }

   data_display = 1;

   return FALSE;
}

#if OLDSTUFF

    if (MainWindow==NULL) MainWindow = lookup_widget(GTK_WIDGET(widget), "window1");

#if 1
#if 0
   if (gPixmap == NULL)
   {
      gPixmap = gdk_pixmap_new(widget->window,
                               widget->allocation.width,
                               widget->allocation.height,
                               -1);
      gdk_draw_rectangle(gPixmap, widget->style->white_gc,
                         TRUE, 0, 0, widget->allocation.width, widget->allocation.height);
    }
#else
   if (gPixmap[0] == NULL)
   {
      // First time in this function. Initialise.
      gPixmap1[0] = gdk_pixmap_new(widget->window,
                                   widget->allocation.width,
                                   widget->allocation.height,
                                   -1);

      gdk_draw_rectangle(gPixmap1[0], widget->style->white_gc,
                          TRUE, 0, 0, widget->allocation.width, widget->allocation.height);

      gPixmap[0] = gPixmap1[0];
   }
   else
   {
      if (gPixmap[0] == gPixmap2[0])
      {
          // Re-size pixmap 1
         if (gPixmap1[0]) gdk_pixmap_unref(gPixmap1[0]);

         gPixmap1[0] = gdk_pixmap_new(widget->window,
                                      widget->allocation.width,
                                      widget->allocation.height,
                                      -1);

         gdk_draw_rectangle(gPixmap1[0], widget->style->white_gc,
                            TRUE, 0, 0, widget->allocation.width, widget->allocation.height);
         if (busy) 
         {
//            printf("Request Update\n");
            // Tell DrawGraph to change update gPixmap
            update_pixmap = 1;
         }
         else
         {
//            printf("Pixmap 1\n");
            gPixmap[0] = gPixmap1[0];
         }
      }
      else
      {
          // Re-size pixmap 2
         if (gPixmap2[0]) gdk_pixmap_unref(gPixmap2[0]);

         gPixmap2[0] = gdk_pixmap_new(widget->window,
                                      widget->allocation.width,
                                      widget->allocation.height,
                                      -1);

         gdk_draw_rectangle(gPixmap2[0], widget->style->white_gc,
                            TRUE, 0, 0, widget->allocation.width, widget->allocation.height);
         if (busy) 
         {
//            printf("Request Update\n");
            // Tell DrawGraph to change update gPixmap
            update_pixmap = 1;
         }
         else
         {
//            printf("Pixmap 2\n");
            gPixmap[0] = gPixmap2[0];
         }
      }
   }
#endif
#else
   if (gPixmap) gdk_pixmap_unref(gPixmap);

   gPixmap = gdk_pixmap_new(widget->window,
                            widget->allocation.width,
                            widget->allocation.height,
                            -1);
#endif

#if 0
    gdk_draw_rectangle(gPixmap, widget->style->white_gc,
                       TRUE, 0, 0, widget->allocation.width, widget->allocation.height);

    gdk_draw_line(gPixmap, widget->style->black_gc, 0, 0, 200, 200);

//    gdk_draw_drawable(widget->window,
//                    widget->style->fg_gc[GTK_WIDGET_STATE (widget)],
//                    gPixmap,
//                    0, 0,
//                    0, 0,
//                    //200, 200);
//                    widget->allocation.width,widget->allocation.height);
#endif
  return FALSE;
#endif


// Drawing Area1 ////////////////////////////////////////////////////////////////////////

gboolean
on_drawingarea1_configure_event        (GtkWidget         *widget,
                                        GdkEventConfigure *event,
                                        gpointer           user_data)
{
   return on_drawingarea_configure_event(widget, event, user_data, 0);
}

gboolean
on_drawingarea1_expose_event           (GtkWidget       *widget,
                                        GdkEventExpose  *event,
                                        gpointer         user_data)
{
    gdk_draw_drawable(widget->window,
                      widget->style->fg_gc[GTK_WIDGET_STATE (widget)],
                      gPixmap[0],
                      0, 0,
                      0, 0,
                      widget->allocation.width,widget->allocation.height);
   return FALSE;
}

// Drawing Area2 ////////////////////////////////////////////////////////////////////////

gboolean
on_drawingarea2_configure_event        (GtkWidget       *widget,
                                        GdkEventConfigure *event,
                                        gpointer         user_data)
{
   return on_drawingarea_configure_event(widget, event, user_data, 1);
}


gboolean
on_drawingarea2_expose_event           (GtkWidget       *widget,
                                        GdkEventExpose  *event,
                                        gpointer         user_data)
{
   if (gPixmap[1] != NULL)
   {
      gdk_draw_drawable(widget->window,
                        widget->style->fg_gc[GTK_WIDGET_STATE (widget)],
                        gPixmap[1],
                        0, 0,
                        0, 0,
                        widget->allocation.width,widget->allocation.height);
   }
   return FALSE;
}

// Drawing Area3 ////////////////////////////////////////////////////////////////////////

gboolean
on_drawingarea3_configure_event        (GtkWidget       *widget,
                                        GdkEventConfigure *event,
                                        gpointer         user_data)
{
   return on_drawingarea_configure_event(widget, event, user_data, 2);

  return FALSE;
}


gboolean
on_drawingarea3_expose_event           (GtkWidget       *widget,
                                        GdkEventExpose  *event,
                                        gpointer         user_data)
{
   if (gPixmap[2] != NULL)
   {
      gdk_draw_drawable(widget->window,
                        widget->style->fg_gc[GTK_WIDGET_STATE (widget)],
                        gPixmap[2],
                        0, 0,
                        0, 0,
                        widget->allocation.width,widget->allocation.height);
   }

  return FALSE;
}

// Drawing Area4 ////////////////////////////////////////////////////////////////////////

gboolean
on_drawingarea4_configure_event        (GtkWidget       *widget,
                                        GdkEventConfigure *event,
                                        gpointer         user_data)
{
   return on_drawingarea_configure_event(widget, event, user_data, 3);

  return FALSE;
}


gboolean
on_drawingarea4_expose_event           (GtkWidget       *widget,
                                        GdkEventExpose  *event,
                                        gpointer         user_data)
{
   if (gPixmap[3] != NULL)
   {
      gdk_draw_drawable(widget->window,
                        widget->style->fg_gc[GTK_WIDGET_STATE (widget)],
                        gPixmap[3],
                        0, 0,
                        0, 0,
                        widget->allocation.width,widget->allocation.height);
   }

  return FALSE;
}


////////////////////////////////////////////////////////////////////////////////
// File -> Start option
////////////////////////////////////////////////////////////////////////////////

int paused = 1;

int tid;

int loadfile;

void *ThreadServeBoard(void *ptr)
{
   while (!stopthread)
   {
      if (paused)
      {
         while (paused)
         {
             HeDelay(100);
         }
      }
      else
      {
         //GetDrawWindow();
         function0();
      }
   }
   stopthread=1;
}

int StartMyThread(void)
{
   int r;
   void *ptr = &tid;

   stopthread = 0;
   r = pthread_create(&tid, NULL, ThreadServeBoard, ptr);
   if (r != 0)
   {
      switch (r)
      {
         case EAGAIN:
            printf("Cannot start thread for board: too many threads.");
            break;
         case EINVAL:
            printf("Cannot start thread for board: invalid argument.");
            break;
         default    :
            printf("Cannot start thread for board: unknown error %d.", r);
            break;
      }
      return 0;
   }
   return 1;
}

void
on_start1_activate                     (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{
   if (stopthread==1)
   {
      MainWindow = lookup_widget(GTK_WIDGET(menuitem), "window1");

      if (StartMyThread())
      {
         paused = 0;
      }
   }
}

void
on_stop1_activate                      (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{
   stopthread = 1;
   loadfile   = 0;
}


////////////////////////////////////////////////////////////////////////////////
// AD Channels option
////////////////////////////////////////////////////////////////////////////////

int adchan_select = 2;
int adchans       = 2;
GtkWidget *ADWindow;

void
on_ad_channels1_activate               (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{
   GtkWidget *radiobutton;

   // Display window
   ADWindow  = create_window2();
   gtk_widget_show(ADWindow);

   // Activate current selection
   adchan_select = adchans;
   switch (adchan_select)
   {
     case 0  : radiobutton = lookup_widget(GTK_WIDGET(ADWindow), "radiobutton3");
               gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(radiobutton), TRUE);
               break;
     case 1  : radiobutton = lookup_widget(GTK_WIDGET(ADWindow), "radiobutton4");
               gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(radiobutton), TRUE);
               break;
     default : radiobutton = lookup_widget(GTK_WIDGET(ADWindow), "radiobutton5");
               gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(radiobutton), TRUE);
               break;
   }
}

void
on_no_AD_channels_clicked              (GtkButton       *button,
                                        gpointer         user_data)
{
   adchan_select = 0;
}


void
on_one_AD_channel_clicked              (GtkButton       *button,
                                        gpointer         user_data)
{
   adchan_select = 1;
}


void
on_two_AD_channels_clicked             (GtkButton       *button,
                                        gpointer         user_data)
{
   adchan_select = 2;
}


void
on_ok_clicked_adchan                   (GtkButton       *button,
                                        gpointer         user_data)
{
   adchans = adchan_select;
   gtk_widget_hide(ADWindow);
}


void
on_cancel_clicked_adchan               (GtkButton       *button,
                                        gpointer         user_data)
{
   gtk_widget_hide(ADWindow);
}

////////////////////////////////////////////////////////////////////////////////
// DA Channels option
////////////////////////////////////////////////////////////////////////////////

int dachan_select = 2;
int dachans       = 2;
GtkWidget *DAWindow;

void
on_da_channels1_activate               (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{
   GtkWidget *radiobutton;

   // Display window
   DAWindow  = create_window3();
   gtk_widget_show(DAWindow);

   // Activate current selection
   dachan_select = dachans;
   switch (dachan_select)
   {
     case 0  : radiobutton = lookup_widget(GTK_WIDGET(DAWindow), "radiobutton6");
               gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(radiobutton), TRUE);
               break;
     case 1  : radiobutton = lookup_widget(GTK_WIDGET(DAWindow), "radiobutton7");
               gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(radiobutton), TRUE);
               break;
     default : radiobutton = lookup_widget(GTK_WIDGET(DAWindow), "radiobutton8");
               gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(radiobutton), TRUE);
               break;
   }

}

void
on_rno_DA_channels_clicked             (GtkButton       *button,
                                        gpointer         user_data)
{
   dachan_select = 0;
}


void
on_one_DA_channel_clicked              (GtkButton       *button,
                                        gpointer         user_data)
{
   dachan_select = 1;
}


void
on_two_DA_channels_clicked             (GtkButton       *button,
                                        gpointer         user_data)
{
   dachan_select = 2;
}


void
on_ok_clicked_dachan                   (GtkButton       *button,
                                        gpointer         user_data)
{
   dachans = dachan_select;
   gtk_widget_hide(DAWindow);
}


void
on_cancel_clicked_dachan               (GtkButton       *button,
                                        gpointer         user_data)
{
   gtk_widget_hide(DAWindow);
}

////////////////////////////////////////////////////////////////////////////////
// File Options option
////////////////////////////////////////////////////////////////////////////////

void
on_load_file_options1_activate         (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{

}

////////////////////////////////////////////////////////////////////////////////
// Slot option
////////////////////////////////////////////////////////////////////////////////

int slotnumber_select = 1;
extern int slotnumber;
GtkWidget *SlotWindow;

void
on_slot_number1_activate               (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{
   GtkWidget *radiobutton;

   // Display window
   SlotWindow  = create_window5();
   gtk_widget_show(SlotWindow);

   // Activate current selection
   slotnumber_select = slotnumber;
   switch (slotnumber_select)
   {
     case 2  : radiobutton = lookup_widget(GTK_WIDGET(SlotWindow), "radiobutton10");
               gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(radiobutton), TRUE);
               break;
     case 3  : radiobutton = lookup_widget(GTK_WIDGET(SlotWindow), "radiobutton11");
               gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(radiobutton), TRUE);
               break;
     case 4  : radiobutton = lookup_widget(GTK_WIDGET(SlotWindow), "radiobutton12");
               gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(radiobutton), TRUE);
               break;
     default : radiobutton = lookup_widget(GTK_WIDGET(SlotWindow), "radiobutton9");
               gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(radiobutton), TRUE);
               break;
   }
}

void
on_slot1_clicked                       (GtkButton       *button,
                                        gpointer         user_data)
{
   slotnumber_select = 1;
}


void
on_slot2_clicked                       (GtkButton       *button,
                                        gpointer         user_data)
{
   slotnumber_select = 2;
}


void
on_slot3_clicked                       (GtkButton       *button,
                                        gpointer         user_data)
{
   slotnumber_select = 3;
}

void
on_slot4_clicked                       (GtkButton       *button,
                                        gpointer         user_data)
{
   slotnumber_select = 4;
}


void
on_slot_ok_clicked                     (GtkButton       *button,
                                        gpointer         user_data)
{
   slotnumber = slotnumber_select;
   gtk_widget_hide(SlotWindow);
}


void
on_cancel_slot_clicked                 (GtkButton       *button,
                                        gpointer         user_data)
{
   gtk_widget_hide(SlotWindow);
}

#if FFT
////////////////////////////////////////////////////////////////////////////////
// DDS Frequency
////////////////////////////////////////////////////////////////////////////////

extern float ddsfreq;
GtkWidget *DDSFreqWindow;

void
on_dds_frequency1_activate             (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{
   GtkWidget *editbox;
   char       str[256];

   // Display window
   DDSFreqWindow     = create_window9();
   gtk_widget_show(DDSFreqWindow);

   sprintf(str, "%.4f", ddsfreq);
   editbox           = lookup_widget(GTK_WIDGET(DDSFreqWindow), "ddsfreq");
   gtk_entry_set_text(GTK_ENTRY(editbox), str);    
}


void
on_ddsfreq_OK_clicked                  (GtkButton       *button,
                                        gpointer         user_data)
{
   GtkWidget *editbox;
   char      *str;

   editbox    = lookup_widget(GTK_WIDGET(DDSFreqWindow), "ddsfreq");
   str        = gtk_editable_get_chars(GTK_EDITABLE(editbox), 0, -1);
   ddsfreq    = atof(str);
   controlsem = 2;
   gtk_widget_hide(DDSFreqWindow);
}


void
on_ddsfreq_cancel_clicked              (GtkButton       *button,
                                        gpointer         user_data)
{
   gtk_widget_hide(DDSFreqWindow);
}

////////////////////////////////////////////////////////////////////////////////
// FFT Window
////////////////////////////////////////////////////////////////////////////////

int window_select = 1;
extern int fftwindow;
GtkWidget *FFTWindow;

void
on_fftwindow_activate                  (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{
   GtkWidget *radiobutton;

   // Display window
   FFTWindow  = create_window10();
   gtk_widget_show(FFTWindow);

   // Activate current selection
   window_select = fftwindow;
   switch (window_select)
   {
     case 0  : radiobutton = lookup_widget(GTK_WIDGET(FFTWindow), "kaiserbessel");
               gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(radiobutton), TRUE);
               break;
     default : radiobutton = lookup_widget(GTK_WIDGET(FFTWindow), "rectangular");
               gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(radiobutton), TRUE);
               break;
   }
}

void
on_window_ok_clicked                   (GtkButton       *button,
                                        gpointer         user_data)
{
   GtkWidget *radiobutton;

   fftwindow = 0;
   radiobutton   = lookup_widget(GTK_WIDGET(FFTWindow), "rectangular");
   if (gtk_toggle_button_get_active(GTK_TOGGLE_BUTTON(radiobutton))) fftwindow = 1;
   controlsem=3;
   gtk_widget_hide(FFTWindow);
}


void
on_window_cancel_clicked               (GtkButton       *button,
                                        gpointer         user_data)
{
   gtk_widget_hide(FFTWindow);
}
#endif

////////////////////////////////////////////////////////////////////////////////
// Graph channel 1 option
////////////////////////////////////////////////////////////////////////////////

struct graphdata
{
	int autoscale;
	int data_type;
	int min_y_value;
	int max_y_value;
	int hex;
};

int htol(char *str, int radix)
{
	int i=0;
	int n=0;
	int sign=1;

	while (str[i])
	{
		switch (tolower(str[i]))
		{
		case '-': sign=-1; break;
		case '0': n=n*radix+ 0; break;
		case '1': if (radix> 0) n=n*radix+ 1; else return sign*n;
				  break;
		case '2': if (radix> 2) n=n*radix+ 2; else return sign*n;
			      break;
		case '3': if (radix> 3) n=n*radix+ 3; else return sign*n;
			      break;
		case '4': if (radix> 4) n=n*radix+ 4; else return sign*n;
			      break;
		case '5': if (radix> 5) n=n*radix+ 5; else return sign*n;
			      break;
		case '6': if (radix> 6) n=n*radix+ 6; else return sign*n;
			      break;
		case '7': if (radix> 7) n=n*radix+ 7; else return sign*n;
			      break;
		case '8': if (radix> 8) n=n*radix+ 8; else return sign*n;
			      break;
		case '9': if (radix> 9) n=n*radix+ 9; else return sign*n;
			      break;
		case 'a': if (radix>10) n=n*radix+10; else return sign*n;
			      break;
		case 'b': if (radix>11) n=n*radix+11; else return sign*n;
			      break;
		case 'c': if (radix>12) n=n*radix+12; else return sign*n;
			      break;
		case 'd': if (radix>13) n=n*radix+13; else return sign*n;
			      break;
		case 'e': if (radix>14) n=n*radix+14; else return sign*n;
			      break;
		case 'f': if (radix>15) n=n*radix+15; else return sign*n;
			      break;
		default : return sign*n;
		}
		i++;
	}
	return sign*n;
}

void ltoh(int val, char *str, int radix)
{
	int  sign=0, i=0;
	int  j, digit;
	char lstr[32];

	if (val==0)
	{
		str[0]='0';
		str[1]= 0 ;
		return;
	}

	if (val<0)
	{
		val  = -val;
		sign = 1;
	}

	while (val)
	{
		digit = val%radix;
		val   = val/radix;
		switch (digit)
		{
		case 0x0: lstr[i++] = '0'; break;
		case 0x1: lstr[i++] = '1'; break;
		case 0x2: lstr[i++] = '2'; break;
		case 0x3: lstr[i++] = '3'; break;
		case 0x4: lstr[i++] = '4'; break;
		case 0x5: lstr[i++] = '5'; break;
		case 0x6: lstr[i++] = '6'; break;
		case 0x7: lstr[i++] = '7'; break;
		case 0x8: lstr[i++] = '8'; break;
		case 0x9: lstr[i++] = '9'; break;
		case 0xa: lstr[i++] = 'a'; break;
		case 0xb: lstr[i++] = 'b'; break;
		case 0xc: lstr[i++] = 'c'; break;
		case 0xd: lstr[i++] = 'd'; break;
		case 0xe: lstr[i++] = 'e'; break;
		case 0xf: lstr[i++] = 'f'; break;
		default : lstr[i++] =  0 ; return;
		}
	}
	if (sign)
	{
		str[0]='-';
		for (j=0; j<i; j++)
		{
			str[j+1] = lstr[i-j-1];
		}
		str[j+1] = 0;
	}
	else
	{
		for (j=0; j<i; j++)
		{
			str[j  ] = lstr[i-j-1];
		}
		str[j  ] = 0;
	}
}

#if FFT
struct graphdata ChGraphData[2] = { { 0, 1, -0x1fff, 0x1fff, 1 }, { 0, 1, -0x1fff, 0x1fff, 1 } };
#else
#if DDC
struct graphdata ChGraphData[2] = { { 0, 1, -0x1fff, 0x1fff, 1 }, { 0, 1, -0x1fff, 0x1fff, 1 } };
#else
struct graphdata ChGraphData[2] = { { 0, 1,  -0x7ff,  0x7ff, 1 }, { 0, 1,  -0x7ff,  0x7ff, 1 } };
#endif
#endif

int data_type[2];
int auto_scale[2];
int grhex[2];
int quiet[2];
GtkWidget *Gr1Window;
GtkWidget *Gr2Window;

void
on_channel_1_graph1_activate           (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{
   GtkWidget *radiobutton;
   GtkWidget *editbox;
   char       str[256];

   // Display window
   Gr1Window  = create_window6();
   gtk_widget_show(Gr1Window);

   // Data Type selection
   data_type[0] = ChGraphData[0].data_type;
   switch (data_type[0])
   {
     case 1  : radiobutton = lookup_widget(GTK_WIDGET(Gr1Window), "radiobutton14");
               gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(radiobutton), TRUE);
               break;
     case 2  : radiobutton = lookup_widget(GTK_WIDGET(Gr1Window), "radiobutton15");
               gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(radiobutton), TRUE);
               break;
     case 3  : radiobutton = lookup_widget(GTK_WIDGET(Gr1Window), "radiobutton16");
               gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(radiobutton), TRUE);
               break;
     default : radiobutton = lookup_widget(GTK_WIDGET(Gr1Window), "radiobutton13");
               gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(radiobutton), TRUE);
               break;
   }

   // AutoScale selection
   auto_scale[0] = ChGraphData[0].autoscale;
   switch (auto_scale[0])
   {
     case 0  : radiobutton = lookup_widget(GTK_WIDGET(Gr1Window), "radiobutton18");
               gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(radiobutton), TRUE);
               break;
     default : radiobutton = lookup_widget(GTK_WIDGET(Gr1Window), "radiobutton17");
               gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(radiobutton), TRUE);
               break;
   }

   // Y values
   grhex[0] = ChGraphData[0].hex;
   if (grhex[0])
   {
      quiet[0]    = 1;
      radiobutton = lookup_widget(GTK_WIDGET(Gr1Window), "checkbutton1");
      gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(radiobutton), TRUE);
      // The above function triggers one call to the event handler. We
      // use 'quiet' to indicate nothing needs to be done.
      quiet[0]    = 0;

      editbox = lookup_widget(GTK_WIDGET(Gr1Window), "entry2");
      ltoh(ChGraphData[0].max_y_value, str, 16);
      gtk_entry_set_text(GTK_ENTRY(editbox), str);
      editbox = lookup_widget(GTK_WIDGET(Gr1Window), "entry3");
      ltoh(ChGraphData[0].min_y_value, str, 16);
      gtk_entry_set_text(GTK_ENTRY(editbox), str);
   }
   else
   {
      editbox = lookup_widget(GTK_WIDGET(Gr1Window), "entry2");
      ltoh(ChGraphData[0].max_y_value, str, 10);
      gtk_entry_set_text(GTK_ENTRY(editbox), str);
      editbox = lookup_widget(GTK_WIDGET(Gr1Window), "entry3");
      ltoh(ChGraphData[0].min_y_value, str, 10);
      gtk_entry_set_text(GTK_ENTRY(editbox), str);
   }
}

void
on_gr1_si_clicked                      (GtkButton       *button,
                                        gpointer         user_data)
{
   data_type[0] = 0;
}


void
on_gr1_ss_clicked                      (GtkButton       *button,
                                        gpointer         user_data)
{
   data_type[0] = 1;
}


void
on_gr1_ui_clicked                      (GtkButton       *button,
                                        gpointer         user_data)
{
   data_type[0] = 2;
}


void
on_gr1_us_clicked                      (GtkButton       *button,
                                        gpointer         user_data)
{
   data_type[0] = 3;
}


void
on_gr1_autoscale_on_clicked            (GtkButton       *button,
                                        gpointer         user_data)
{
   auto_scale[0] = 1;
}


void
on_gr1_autoscale_off_clicked           (GtkButton       *button,
                                        gpointer         user_data)
{
   auto_scale[0] = 0;
}


void
on_yvalue_clicked                      (GtkButton       *button,
                                        gpointer         user_data)
{
}

void
on_yvalue_toggled                      (GtkToggleButton *togglebutton,
                                        gpointer         user_data)
{
   int        ymax, ymin;
   GtkWidget *editbox;
   char      *str;

   if (!quiet[0])
   {
      if (grhex[0])
      {
         // Retrieve numbers
         editbox  = lookup_widget(GTK_WIDGET(Gr1Window), "entry2");
         str      = gtk_editable_get_chars(GTK_EDITABLE(editbox), 0, -1);
         ymax     = htol(str, 16);
         editbox  = lookup_widget(GTK_WIDGET(Gr1Window), "entry3");
         str      = gtk_editable_get_chars(GTK_EDITABLE(editbox), 0, -1);
         ymin     = htol(str, 16);
         // HEX -> DEC
         grhex[0] = 0;
         // Display Y max & min as decimal
         editbox = lookup_widget(GTK_WIDGET(Gr1Window), "entry2");
         ltoh(ymax, str, 10);
         gtk_entry_set_text(GTK_ENTRY(editbox), str);
         editbox = lookup_widget(GTK_WIDGET(Gr1Window), "entry3");
         ltoh(ymin, str, 10);
         gtk_entry_set_text(GTK_ENTRY(editbox), str);
      }
      else
      {
         // Retrieve numbers
         editbox = lookup_widget(GTK_WIDGET(Gr1Window), "entry2");
         str     = gtk_editable_get_chars(GTK_EDITABLE(editbox), 0, -1);
         ymax    = htol(str, 10);
         editbox = lookup_widget(GTK_WIDGET(Gr1Window), "entry3");
         str     = gtk_editable_get_chars(GTK_EDITABLE(editbox), 0, -1);
         ymin    = htol(str, 10);
         // DEC -> HEX
         grhex[0] = 1;
         // Display Y max & min as decimal
         editbox = lookup_widget(GTK_WIDGET(Gr1Window), "entry2");
         ltoh(ymax, str, 16);
         gtk_entry_set_text(GTK_ENTRY(editbox), str);
         editbox = lookup_widget(GTK_WIDGET(Gr1Window), "entry3");
         ltoh(ymin, str, 16);
         gtk_entry_set_text(GTK_ENTRY(editbox), str);
      }
   }
}

void
on_gr1_ok_clicked                      (GtkButton       *button,
                                        gpointer         user_data)
{
   GtkWidget *editbox;
   char      *str;
   int        ymax, ymin;

   // Get Y max and min
   if (grhex[0])
   {
      editbox = lookup_widget(GTK_WIDGET(Gr1Window), "entry2");
      str     = gtk_editable_get_chars(GTK_EDITABLE(editbox), 0, -1);
      ymax    = htol(str, 16);
      editbox = lookup_widget(GTK_WIDGET(Gr1Window), "entry3");
      str     = gtk_editable_get_chars(GTK_EDITABLE(editbox), 0, -1);
      ymin    = htol(str, 16);
   }
   else
   {
      editbox = lookup_widget(GTK_WIDGET(Gr1Window), "entry2");
      str     = gtk_editable_get_chars(GTK_EDITABLE(editbox), 0, -1);
      ymax    = htol(str, 10);
      editbox = lookup_widget(GTK_WIDGET(Gr1Window), "entry3");
      str     = gtk_editable_get_chars(GTK_EDITABLE(editbox), 0, -1);
      ymin    = htol(str, 10);
   }
   ChGraphData[0].data_type   = data_type[0];
   ChGraphData[0].autoscale   = auto_scale[0];
   ChGraphData[0].hex         = grhex[0];
   ChGraphData[0].max_y_value = ymax;
   ChGraphData[0].min_y_value = ymin;
   gtk_widget_hide(Gr1Window);
}


void
on_gr1_cancel_clicked                  (GtkButton       *button,
                                        gpointer         user_data)
{
   gtk_widget_hide(Gr1Window);
}


////////////////////////////////////////////////////////////////////////////////
// Graph channel 2 option
////////////////////////////////////////////////////////////////////////////////

void
on_channel_2_graph1_activate           (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{
   GtkWidget *radiobutton;
   GtkWidget *editbox;
   char       str[256];

   // Display window
   Gr2Window  = create_window7();
   gtk_widget_show(Gr2Window);

   // Data Type selection
   data_type[1] = ChGraphData[1].data_type;
   switch (data_type[1])
   {
     case 1  : radiobutton = lookup_widget(GTK_WIDGET(Gr2Window), "radiobutton20");
               gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(radiobutton), TRUE);
               break;
     case 2  : radiobutton = lookup_widget(GTK_WIDGET(Gr2Window), "radiobutton21");
               gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(radiobutton), TRUE);
               break;
     case 3  : radiobutton = lookup_widget(GTK_WIDGET(Gr2Window), "radiobutton22");
               gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(radiobutton), TRUE);
               break;
     default : radiobutton = lookup_widget(GTK_WIDGET(Gr2Window), "radiobutton19");
               gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(radiobutton), TRUE);
               break;
   }

   // AutoScale selection
   auto_scale[1] = ChGraphData[1].autoscale;
   switch (auto_scale[1])
   {
     case 0  : radiobutton = lookup_widget(GTK_WIDGET(Gr2Window), "radiobutton24");
               gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(radiobutton), TRUE);
               break;
     default : radiobutton = lookup_widget(GTK_WIDGET(Gr2Window), "radiobutton23");
               gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(radiobutton), TRUE);
               break;
   }

   // Y values
   grhex[1] = ChGraphData[1].hex;
   if (grhex[1])
   {
      quiet[1]    = 1;
      radiobutton = lookup_widget(GTK_WIDGET(Gr2Window), "checkbutton2");
      gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(radiobutton), TRUE);
      // The above function triggers one call to the event handler. We
      // use 'quiet' to indicate nothing needs to be done.
      quiet[1]    = 0;

      editbox = lookup_widget(GTK_WIDGET(Gr2Window), "entry4");
      ltoh(ChGraphData[1].max_y_value, str, 16);
      gtk_entry_set_text(GTK_ENTRY(editbox), str);
      editbox = lookup_widget(GTK_WIDGET(Gr2Window), "entry5");
      ltoh(ChGraphData[1].min_y_value, str, 16);
      gtk_entry_set_text(GTK_ENTRY(editbox), str);
   }
   else
   {
      editbox = lookup_widget(GTK_WIDGET(Gr2Window), "entry4");
      ltoh(ChGraphData[1].max_y_value, str, 10);
      gtk_entry_set_text(GTK_ENTRY(editbox), str);
      editbox = lookup_widget(GTK_WIDGET(Gr2Window), "entry5");
      ltoh(ChGraphData[1].min_y_value, str, 10);
      gtk_entry_set_text(GTK_ENTRY(editbox), str);
   }

}

void
on_gr2_si_clicked                      (GtkButton       *button,
                                        gpointer         user_data)
{
   data_type[1] = 0;
}


void
on_gr2_ss_clicked                      (GtkButton       *button,
                                        gpointer         user_data)
{
   data_type[1] = 1;
}


void
on_gr2_ui_clicked                      (GtkButton       *button,
                                        gpointer         user_data)
{
   data_type[1] = 2;
}


void
on_gr2_us_clicked                      (GtkButton       *button,
                                        gpointer         user_data)
{
   data_type[1] = 3;
}


void
on_gr2_autoscale_on_clicked            (GtkButton       *button,
                                        gpointer         user_data)
{
   auto_scale[1] = 1;
}


void
on_gr2_autoscale_off_clicked           (GtkButton       *button,
                                        gpointer         user_data)
{
   auto_scale[1] = 0;
}


void
on_gr2_yvalue_clicked                  (GtkButton       *button,
                                        gpointer         user_data)
{
   int        ymax, ymin;
   GtkWidget *editbox;
   char      *str;

   if (!quiet[1])
   {
      if (grhex[1])
      {
         // Retrieve numbers
         editbox  = lookup_widget(GTK_WIDGET(Gr2Window), "entry4");
         str      = gtk_editable_get_chars(GTK_EDITABLE(editbox), 0, -1);
         ymax     = htol(str, 16);
         editbox  = lookup_widget(GTK_WIDGET(Gr2Window), "entry5");
         str      = gtk_editable_get_chars(GTK_EDITABLE(editbox), 0, -1);
         ymin     = htol(str, 16);
         // HEX -> DEC
         grhex[1] = 0;
         // Display Y max & min as decimal
         editbox = lookup_widget(GTK_WIDGET(Gr2Window), "entry4");
         ltoh(ymax, str, 10);
         gtk_entry_set_text(GTK_ENTRY(editbox), str);
         editbox = lookup_widget(GTK_WIDGET(Gr2Window), "entry5");
         ltoh(ymin, str, 10);
         gtk_entry_set_text(GTK_ENTRY(editbox), str);
      }
      else
      {
         // Retrieve numbers
         editbox = lookup_widget(GTK_WIDGET(Gr2Window), "entry4");
         str     = gtk_editable_get_chars(GTK_EDITABLE(editbox), 0, -1);
         ymax    = htol(str, 10);
         editbox = lookup_widget(GTK_WIDGET(Gr2Window), "entry5");
         str     = gtk_editable_get_chars(GTK_EDITABLE(editbox), 0, -1);
         ymin    = htol(str, 10);
         // DEC -> HEX
         grhex[1] = 1;
         // Display Y max & min as decimal
         editbox = lookup_widget(GTK_WIDGET(Gr2Window), "entry4");
         ltoh(ymax, str, 16);
         gtk_entry_set_text(GTK_ENTRY(editbox), str);
         editbox = lookup_widget(GTK_WIDGET(Gr2Window), "entry5");
         ltoh(ymin, str, 16);
         gtk_entry_set_text(GTK_ENTRY(editbox), str);
      }
   }

}


void
on_gr2_ok_clicked                      (GtkButton       *button,
                                        gpointer         user_data)
{
   GtkWidget *editbox;
   char      *str;
   int        ymax, ymin;

   // Get Y max and min
   if (grhex[1])
   {
      editbox = lookup_widget(GTK_WIDGET(Gr2Window), "entry4");
      str     = gtk_editable_get_chars(GTK_EDITABLE(editbox), 0, -1);
      ymax    = htol(str, 16);
      editbox = lookup_widget(GTK_WIDGET(Gr2Window), "entry5");
      str     = gtk_editable_get_chars(GTK_EDITABLE(editbox), 0, -1);
      ymin    = htol(str, 16);
   }
   else
   {
      editbox = lookup_widget(GTK_WIDGET(Gr2Window), "entry4");
      str     = gtk_editable_get_chars(GTK_EDITABLE(editbox), 0, -1);
      ymax    = htol(str, 10);
      editbox = lookup_widget(GTK_WIDGET(Gr2Window), "entry5");
      str     = gtk_editable_get_chars(GTK_EDITABLE(editbox), 0, -1);
      ymin    = htol(str, 10);
   }
   ChGraphData[1].data_type   = data_type[1];
   ChGraphData[1].autoscale   = auto_scale[1];
   ChGraphData[1].hex         = grhex[1];
   ChGraphData[1].max_y_value = ymax;
   ChGraphData[1].min_y_value = ymin;
   gtk_widget_hide(Gr2Window);
}


void
on_gr2_cancel_clicked                  (GtkButton       *button,
                                        gpointer         user_data)
{
   gtk_widget_hide(Gr2Window);
}

////////////////////////////////////////////////////////////////////////////////
// FFT 1 option
////////////////////////////////////////////////////////////////////////////////

#if DDC
int dofft1 = 1;
#else
int dofft1 = 0;
#endif

void
on_channel_1_fft1_activate             (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{

}

void
on_on_fft1_activate                    (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{
   dofft1 = 1;
}


void
on_off_fft1_activate                   (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{
   dofft1 = 0;
}

////////////////////////////////////////////////////////////////////////////////
// FFT 2 option
////////////////////////////////////////////////////////////////////////////////

#if DDC
int dofft2 = 1;
#else
int dofft2 = 0;
#endif

void
on_channel_2_fft1_activate             (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{

}


void
on_on_fft2_activate                    (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{
   dofft2 = 1;
}


void
on_off_fft2_activate                   (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{
   dofft2 = 0;
}


////////////////////////////////////////////////////////////////////////////////
// Control menu
////////////////////////////////////////////////////////////////////////////////

void
on_function_5_activate                 (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{
   function1();
}


void
on_function_6_activate                 (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{
   function2();
}


void
on_function_7_activate                 (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{
   function3();
}


void
on_function_8_activate                 (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{
   function4();
}

////////////////////////////////////////////////////////////////////////////////
// About menu
////////////////////////////////////////////////////////////////////////////////

void
on_about_1_activate                    (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{

}

